SET define off;

--
-- 
-- ____________________________________________________________________________________________
--  /!\ ATTENTION /!\  fichier encodé en UTF-8   (  il peut  contenir des é è ç à î ê ô ... )
-- ____________________________________________________________________________________________
--
--

/*
-- nettoyage
DROP TABLE CKTL_GED.STOCKAGE_URL CASCADE constraints;
DROP TABLE CKTL_GED."DOCUMENT" CASCADE constraints;
DROP TABLE CKTL_GED.DELEGUE_STOCKAGE CASCADE constraints;
DROP TABLE CKTL_GED.TYPE_DOCUMENT CASCADE constraints;
DROP TABLE CKTL_GED.ERATTACHMENTDATA CASCADE constraints;
DROP TABLE CKTL_GED.ERATTACHMENT CASCADE constraints;
DROP TABLE CKTL_GED.DB_VERSION CASCADE constraints;


DROP SEQUENCE CKTL_GED.STOCKAGE_URL_SEQ;
DROP SEQUENCE CKTL_GED.DOCUMENT_SEQ;
DROP SEQUENCE CKTL_GED.DELEGUE_STOCKAGE_SEQ;
DROP SEQUENCE CKTL_GED.TYPE_DOCUMENT_SEQ;
DROP SEQUENCE CKTL_GED.ERATTACHMENTDATA_SEQ ;
DROP SEQUENCE CKTL_GED.ERATTACHMENT_SEQ ;
DROP SEQUENCE CKTL_GED.DB_VERSION_SEQ ;
*/
-- creation des sequences
CREATE SEQUENCE CKTL_GED.STOCKAGE_URL_SEQ START WITH 1 NOCYCLE nocache;
CREATE SEQUENCE CKTL_GED.TYPE_DOCUMENT_SEQ START WITH 1 NOCYCLE nocache;
CREATE SEQUENCE CKTL_GED.DELEGUE_STOCKAGE_SEQ START WITH 1 NOCYCLE nocache;
CREATE SEQUENCE CKTL_GED.DOCUMENT_SEQ START WITH 1 NOCYCLE nocache;
CREATE SEQUENCE CKTL_GED.ERATTACHMENTDATA_SEQ START WITH 1 NOCYCLE nocache;
CREATE SEQUENCE CKTL_GED.ERATTACHMENT_SEQ START WITH 1 NOCYCLE nocache;
CREATE SEQUENCE CKTL_GED.DB_VERSION_SEQ START WITH 1 NOCYCLE nocache;




CREATE TABLE CKTL_GED.TYPE_DOCUMENT 
	(
		Td_ID NUMBER(38,0) NOT NULL,
		Td_STR_ID VARCHAR2(255) NOT null,
		Td_LIBELLE VARCHAR2(255) NOT NULL,
		td_dtd clob
	);
	CREATE UNIQUE INDEX CKTL_GED.PK_TYPE_DOCUMENT ON CKTL_GED.TYPE_DOCUMENT (td_ID) TABLESPACE INDX_GRHUM;
	ALTER TABLE CKTL_GED.TYPE_DOCUMENT ADD CONSTRAINT PK_TYPE_DOCUMENT PRIMARY KEY (Td_ID) using index CKTL_GED.PK_TYPE_DOCUMENT;
	CREATE UNIQUE INDEX CKTL_GED.UNQ_TYPE_DOCUMENT_STR_ID ON CKTL_GED.TYPE_DOCUMENT (Td_STR_ID) TABLESPACE INDX_GRHUM;
	ALTER TABLE CKTL_GED.TYPE_DOCUMENT ADD CONSTRAINT UNQ_TYPE_DOCUMENT_STR_ID UNIQUE (Td_STR_ID) using index CKTL_GED.UNQ_TYPE_DOCUMENT_STR_ID;

   COMMENT ON TABLE CKTL_GED.TYPE_DOCUMENT IS 'Les types de documents';
   COMMENT ON COLUMN CKTL_GED.TYPE_DOCUMENT.TD_ID IS 'Clé';
   COMMENT ON COLUMN CKTL_GED.TYPE_DOCUMENT.TD_STR_ID IS 'Identifiant signifiant du type de document (au format org.cocktail.gfc.depense.devis, org.cocktail.grh.contrat, etc.)';
   COMMENT ON COLUMN CKTL_GED.TYPE_DOCUMENT.TD_LIBELLE IS 'Libellé du type de document';
   COMMENT ON COLUMN CKTL_GED.TYPE_DOCUMENT.td_dtd IS 'DTD xml pour associer des metadonnees au document';

CREATE TABLE CKTL_GED.DELEGUE_STOCKAGE 
	(
		DS_ID NUMBER(38,0) NOT NULL,
		DS_STR_ID VARCHAR2(255) NOT null,
		DS_LIBELLE VARCHAR2(255) NOT NULL
	);
	CREATE UNIQUE INDEX CKTL_GED.PK_DELEGUE_STOCKAGE ON CKTL_GED.DELEGUE_STOCKAGE (ds_ID) TABLESPACE INDX_GRHUM;  
	ALTER TABLE CKTL_GED.DELEGUE_STOCKAGE ADD CONSTRAINT PK_DELEGUE_STOCKAGE PRIMARY KEY (DS_ID) using index CKTL_GED.PK_DELEGUE_STOCKAGE;
	CREATE UNIQUE INDEX CKTL_GED.UNQ_DELEGUE_STOCKAGE_STR_ID ON CKTL_GED.DELEGUE_STOCKAGE (DS_STR_ID) TABLESPACE INDX_GRHUM;
	ALTER TABLE CKTL_GED.DELEGUE_STOCKAGE ADD CONSTRAINT UNQ_DELEGUE_STOCKAGE_STR_ID UNIQUE (DS_STR_ID) using index CKTL_GED.UNQ_DELEGUE_STOCKAGE_STR_ID;

   COMMENT ON TABLE CKTL_GED.DELEGUE_STOCKAGE IS 'Les délégués de stockages possibles';
   COMMENT ON COLUMN CKTL_GED.DELEGUE_STOCKAGE.DS_ID IS 'Clé';
   COMMENT ON COLUMN CKTL_GED.DELEGUE_STOCKAGE.DS_STR_ID IS 'Identifiant signifiant du délégué de stockage (au format org.cocktail.typestockage.url, er.attachment, etc.)';
   COMMENT ON COLUMN CKTL_GED.DELEGUE_STOCKAGE.DS_LIBELLE IS 'Libellé du délégué de stockage';


CREATE TABLE CKTL_GED.DOCUMENT 
	(
		doc_ID NUMBER(38,0) NOT NULL,
		td_ID  NUMBER(38,0) NOT NULL,
		ds_ID  NUMBER(38,0) NOT NULL,
		doc_external_id NUMBER(38,0) NOT NULL,
		pers_id number(38,0) not null
	);
	CREATE UNIQUE INDEX CKTL_GED.PK_DOCUMENT ON CKTL_GED."DOCUMENT" (doc_ID) TABLESPACE INDX_GRHUM;  
	ALTER TABLE CKTL_GED."DOCUMENT"  ADD CONSTRAINT PK_DOCUMENT PRIMARY KEY (doc_ID) using index CKTL_GED.PK_DOCUMENT;
	CREATE UNIQUE INDEX CKTL_GED.UNQ_DOCUMENT_EXT_ID ON CKTL_GED.DOCUMENT (doc_ID, doc_external_id) TABLESPACE INDX_GRHUM;
	ALTER TABLE CKTL_GED."DOCUMENT"  ADD CONSTRAINT UNQ_DOCUMENT_ext_id UNIQUE (doc_ID, doc_external_id) using index CKTL_GED.UNQ_DOCUMENT_EXT_ID;

   COMMENT ON TABLE CKTL_GED."DOCUMENT" IS 'Les types de documents';
   COMMENT ON COLUMN CKTL_GED."DOCUMENT".doc_ID IS 'Clé';
   COMMENT ON COLUMN CKTL_GED."DOCUMENT".td_ID IS 'Reference au type de document';
   COMMENT ON COLUMN CKTL_GED."DOCUMENT".ds_id IS 'Reference au délégué de stockage';
   COMMENT ON COLUMN CKTL_GED."DOCUMENT".doc_external_id IS 'Reference a l''identifiant dans le systeme de stockage (externe)';
   COMMENT ON COLUMN CKTL_GED."DOCUMENT".pers_id IS 'Reference a la personne qui cree le document';



CREATE TABLE CKTL_GED.STOCKAGE_URL 
	(
		surl_ID NUMBER(38,0) NOT NULL,
		surl_URL  varchar2(4000) NOT NULL
	);
	CREATE UNIQUE INDEX CKTL_GED.PK_STOCKAGE_URL ON CKTL_GED.STOCKAGE_URL (surl_ID) TABLESPACE INDX_GRHUM;  
	ALTER TABLE CKTL_GED."STOCKAGE_URL"  ADD CONSTRAINT PK_STOCKAGE_URL PRIMARY KEY (surl_ID) using index CKTL_GED.PK_STOCKAGE_URL;

   COMMENT ON TABLE CKTL_GED."STOCKAGE_URL" IS 'Les urls stockées';	
   COMMENT ON COLUMN CKTL_GED."STOCKAGE_URL".surl_ID IS 'clé';	
   COMMENT ON COLUMN CKTL_GED."STOCKAGE_URL".surl_URL IS 'URL';	


  CREATE TABLE CKTL_GED.ERATTACHMENT 
   (	
   "ID" NUMBER(38,0) NOT NULL, 
   "ATTDATAID" NUMBER(38,0), 
	"ATTACHMENTSIZE" NUMBER(38,0), 
	"CONFIGURATIONNAME" VARCHAR2(100 BYTE) NULL, 
	"FILESYSTEMPATH" VARCHAR2(255 BYTE), 
	"HEIGHT" NUMBER(38,0)  , 
	"MIMETYPE" VARCHAR2(100 BYTE)  NOT NULL, 
	"ORIGINALFILENAME" VARCHAR2(255 BYTE) NOT NULL, 
	"OWNERID" VARCHAR2(16 BYTE), 
	"PARENTID" NUMBER(38,0), 
	"PROXIED" VARCHAR2(5 BYTE) NOT NULL, 
	"S3PATH" VARCHAR2(1000 BYTE), 
	"STORAGETYPE" VARCHAR2(10 BYTE), 
	"THUMBNAIL" VARCHAR2(10 BYTE), 
	"WEBPATH" VARCHAR2(1000 BYTE) NOT NULL, 
	"WIDTH" NUMBER(38,0), 
	"AVAILABLE" VARCHAR2(5 BYTE) NOT NULL, 
	"CREATIONDATE" DATE  NOT NULL,
	"SMALLDATA" BLOB
   )  TABLESPACE "DATA_GRHUM"  ;
	CREATE UNIQUE INDEX CKTL_GED.PK_ERATTACHMENT ON CKTL_GED.ERATTACHMENT ("ID") TABLESPACE INDX_GRHUM;  
	ALTER TABLE CKTL_GED.ERATTACHMENT  ADD CONSTRAINT PK_ERATTACHMENT PRIMARY KEY ("ID") using index CKTL_GED.PK_ERATTACHMENT;


  CREATE TABLE CKTL_GED.ERATTACHMENTDATA 
   (
	"ID" NUMBER(38,0) NOT NULL,
	"DATA" BLOB
   ) 
  TABLESPACE "DATA_GRHUM" ;
	CREATE UNIQUE INDEX CKTL_GED.PK_ERATTACHMENTDATA ON CKTL_GED.ERATTACHMENTDATA ("ID") TABLESPACE INDX_GRHUM;  
	ALTER TABLE CKTL_GED.ERATTACHMENTDATA  ADD CONSTRAINT PK_ERATTACHMENTDATA PRIMARY KEY ("ID") using index CKTL_GED.PK_ERATTACHMENTDATA;



  CREATE TABLE CKTL_GED.DB_VERSION
    (
	DBV_ID       NUMBER(4)                        NOT NULL,
	DBV_LIBELLE  VARCHAR2(15 BYTE)                NOT NULL,
	DBV_DATE     DATE                             NOT NULL,
	DBV_INSTALL  DATE,
	DBV_COMMENT  VARCHAR2(2000 BYTE)
    )
  TABLESPACE DATA_GRHUM;
	CREATE UNIQUE INDEX CKTL_GED.PK_DB_VERSION ON CKTL_GED.DB_VERSION (DBV_ID) TABLESPACE INDX_GRHUM;
	ALTER TABLE CKTL_GED.DB_VERSION ADD (  CONSTRAINT PK_DB_VERSION  PRIMARY KEY  (DBV_ID) using index CKTL_GED.PK_DB_VERSION);


COMMENT ON TABLE CKTL_GED.DB_VERSION IS 'Historique des versions du schéma du user';
COMMENT ON COLUMN CKTL_GED.DB_VERSION.DBV_COMMENT IS 'Le commentaire : une courte description de cette version de la base de donnees.';
COMMENT ON COLUMN CKTL_GED.DB_VERSION.DBV_ID IS 'Identifiant de la version';
COMMENT ON COLUMN CKTL_GED.DB_VERSION.DBV_LIBELLE IS 'Libelle de la version';
COMMENT ON COLUMN CKTL_GED.DB_VERSION.DBV_DATE IS 'Date de release de la version';
COMMENT ON COLUMN CKTL_GED.DB_VERSION.DBV_INSTALL IS 'Date d''installation de la version. Si non renseigné, la version n''est pas completement installée.';


   
create or replace procedure CKTL_GED.initialise as
	versionStrNum CKTL_GED.DB_VERSION.DBV_LIBELLE%type;
	versionDate CKTL_GED.DB_VERSION.DBV_DATE%type;
begin
	versionStrNum := '1.0.0.0';
	versionDate := to_Date('10/11/2010','dd/mm/yyyy');

	delete from CKTL_GED.DELEGUE_STOCKAGE;
	delete from CKTL_GED.TYPE_DOCUMENT;
	delete from CKTL_GED.DB_VERSION;

	--
	-- DB_VERSION
	--
	INSERT INTO CKTL_GED.DB_VERSION VALUES(CKTL_GED.DB_VERSION_SEQ.NEXTVAL, versionStrNum, versionDate ,NULL,'Initialisation du user');

	INSERT INTO CKTL_GED.DELEGUE_STOCKAGE (DS_ID, DS_STR_ID, DS_LIBELLE) VALUES (CKTL_GED.DELEGUE_STOCKAGE_seq.nextval , 'er.attachment', 'Stockage via le framework ERAttachment');	   
	INSERT INTO CKTL_GED.DELEGUE_STOCKAGE (DS_ID, DS_STR_ID, DS_LIBELLE) VALUES (CKTL_GED.DELEGUE_STOCKAGE_seq.nextval , 'org.cocktail.ged.deleguestockage.stockageurl', 'Stockage des URL');

	INSERT INTO CKTL_GED.TYPE_DOCUMENT (TD_ID, TD_STR_ID, TD_LIBELLE,TD_DTD) VALUES (CKTL_GED.TYPE_DOCUMENT_seq.nextval , 'org.cocktail.ged.typedocument.gfc.depense.devis', 'Devis fournisseur',null );
	INSERT INTO CKTL_GED.TYPE_DOCUMENT (TD_ID, TD_STR_ID, TD_LIBELLE,TD_DTD) VALUES (CKTL_GED.TYPE_DOCUMENT_seq.nextval , 'org.cocktail.ged.typedocument.gfc.depense.facture', 'Facture fournisseur',null );
	INSERT INTO CKTL_GED.TYPE_DOCUMENT (TD_ID, TD_STR_ID, TD_LIBELLE,TD_DTD) VALUES (CKTL_GED.TYPE_DOCUMENT_seq.nextval , 'org.cocktail.ged.typedocument.gfc.depense.bondecommande', 'Bon de commande',null );
		
		--
	-- DB_VERSION
	--
	UPDATE CKTL_GED.DB_VERSION SET DBV_INSTALL=SYSDATE WHERE DBV_LIBELLE=versionStrNum;
	commit;

end initialise;
/
